//+------------------------------------------------------------------+
//|                                                       ea_new.mq4 |
//|                        Copyright 2014, MetaQuotes Software Corp. |
//|                                              http://www.mql5.com |
//+------------------------------------------------------------------+
#property copyright "Copyright 2014, MetaQuotes Software Corp."
#property link      "http://www.mql5.com"
#property version   "1.00"
#property strict

#property show_inputs

extern double lots = 0.1;
extern int order_range = 300;
extern int profit = 2000;
extern int cnt_tick = 2;
extern int magic = 921919;

string symbol;
double or_point, tp_point;

int cnt_tick_buy = 0;
int cnt_tick_sell = 0;


//+------------------------------------------------------------------+
//| Expert initialization function                                   |
//+------------------------------------------------------------------+
int OnInit()
{
	symbol = Symbol();
	or_point = order_range*Point;
	tp_point = profit*Point;
	
	if (AccountFreeMargin() / MarketInfo(symbol, MODE_MARGINREQUIRED) < lots)
	{
		Alert("Lot > FreeMargin/MarginReq");
	}
	
   return(INIT_SUCCEEDED);
}

void OnDeinit(const int reason)
{
}

void OnTick()
{
	bool isBuyOn = false;
	bool isSellOn = false;
	bool isAlreadyBuyStop = false;
	bool isAlreadySellStop = false;

	cnt_tick_buy++;
	cnt_tick_sell++;

	int total = OrdersTotal();

	for (int i=total-1; i>=0; i--)
	{
		if (OrderSelect(i, SELECT_BY_POS) == true)
      {
   		if (OrderSymbol() == symbol && OrderMagicNumber() == magic)
   		{
   			int type = OrderType();
   			double ord_prc = OrderOpenPrice();
   
   			if (type == OP_BUY) isBuyOn = true;
   			else if (type == OP_SELL) isSellOn = true;
   			else if (type == OP_BUYSTOP)
   			{
   				isBuyOn = true;
   		
   				if (isAlreadyBuyStop) bool res = (OrderDelete(OrderTicket()) ); //delete another buystop
   				else isAlreadyBuyStop = true;
   			
   				double buy_value = Ask+or_point;
   				if (cnt_tick_buy > cnt_tick)
   				{
   					if (ord_prc != buy_value) bool res = (OrderModify(OrderTicket(),buy_value,0,buy_value+tp_point,0,CLR_NONE));
   					cnt_tick_buy = 1;
   				}
   			}
   			else if (type == OP_SELLSTOP)
   			{
   				isSellOn = true;
   				
   				if (isAlreadySellStop) bool res = (OrderDelete(OrderTicket()) ); //delete another sellstop
   				else isAlreadySellStop = true;
   				
   				double sell_value = Bid-or_point;
   				if (cnt_tick_sell > cnt_tick)
   				{
   					if (ord_prc != sell_value) bool res =  (OrderModify(OrderTicket(),sell_value,0,sell_value-tp_point,0,CLR_NONE));
   					cnt_tick_sell = 1;
   				}
   			}
   		}
		}
	}

	if (!isBuyOn)  bool res = OrderSend(symbol,OP_BUYSTOP, lots,Ask+or_point,0,0,Ask+or_point+tp_point,"OP BUYSTOP", magic,0,CLR_NONE);
	if (!isSellOn) bool res = OrderSend(symbol,OP_SELLSTOP,lots,Bid-or_point,0,0,Bid-or_point-tp_point,"OP SELLSTOP",magic,0,CLR_NONE);

}

void OnStart()
{
}
//+------------------------------------------------------------------+
